import MSyntax  # type: ignore[import-not-found]
import maya.api.OpenMaya
import maya.api.OpenMayaRender
from _typeshed import Incomplete
from maya.api.OpenMaya import MPxManipulatorNode as MPxManipulatorNode  # type: ignore[attr-defined]
from typing import Any, ClassVar, overload

ourdict: dict
py2dict: dict
key: str
val: str

class M3dView:
    kBoundingBox: ClassVar[int] = ...
    kFlatShaded: ClassVar[int] = ...
    kGouraudShaded: ClassVar[int] = ...
    kWireFrame: ClassVar[int] = ...
    kPoints: ClassVar[int] = ...
    kActive: ClassVar[int] = ...
    kLive: ClassVar[int] = ...
    kDormant: ClassVar[int] = ...
    kInvisible: ClassVar[int] = ...
    kHilite: ClassVar[int] = ...
    kTemplate: ClassVar[int] = ...
    kActiveTemplate: ClassVar[int] = ...
    kActiveComponent: ClassVar[int] = ...
    kLead: ClassVar[int] = ...
    kIntermediateObject: ClassVar[int] = ...
    kActiveAffected: ClassVar[int] = ...
    kNoStatus: ClassVar[int] = ...
    kActiveColors: ClassVar[int] = ...
    kDormantColors: ClassVar[int] = ...
    kTemplateColor: ClassVar[int] = ...
    kBackgroundColor: ClassVar[int] = ...
    kLeft: ClassVar[int] = ...
    kCenter: ClassVar[int] = ...
    kRight: ClassVar[int] = ...
    kDisplayEverything: ClassVar[int] = ...
    kDisplayNurbsCurves: ClassVar[int] = ...
    kDisplayNurbsSurfaces: ClassVar[int] = ...
    kDisplayMeshes: ClassVar[int] = ...
    kDisplayPlanes: ClassVar[int] = ...
    kDisplayLights: ClassVar[int] = ...
    kDisplayCameras: ClassVar[int] = ...
    kDisplayJoints: ClassVar[int] = ...
    kDisplayIkHandles: ClassVar[int] = ...
    kDisplayDeformers: ClassVar[int] = ...
    kDisplayDynamics: ClassVar[int] = ...
    kDisplayParticleInstancers: ClassVar[int] = ...
    kDisplayLocators: ClassVar[int] = ...
    kDisplayDimensions: ClassVar[int] = ...
    kDisplaySelectHandles: ClassVar[int] = ...
    kDisplayPivots: ClassVar[int] = ...
    kDisplayTextures: ClassVar[int] = ...
    kDisplayGrid: ClassVar[int] = ...
    kDisplayCVs: ClassVar[int] = ...
    kDisplayHulls: ClassVar[int] = ...
    kDisplayStrokes: ClassVar[int] = ...
    kDisplaySubdivSurfaces: ClassVar[int] = ...
    kDisplayFluids: ClassVar[int] = ...
    kDisplayFollicles: ClassVar[int] = ...
    kDisplayHairSystems: ClassVar[int] = ...
    kDisplayImagePlane: ClassVar[int] = ...
    kDisplayNCloths: ClassVar[int] = ...
    kDisplayNRigids: ClassVar[int] = ...
    kDisplayDynamicConstraints: ClassVar[int] = ...
    kDisplayManipulators: ClassVar[int] = ...
    kDisplayNParticles: ClassVar[int] = ...
    kExcludeMotionTrails: ClassVar[int] = ...
    kExcludePluginShapes: ClassVar[int] = ...
    kLightAll: ClassVar[int] = ...
    kLightSelected: ClassVar[int] = ...
    kLightActive: ClassVar[int] = ...
    kLightDefault: ClassVar[int] = ...
    kUnused1: ClassVar[int] = ...
    kLightNone: ClassVar[int] = ...
    kDefaultQualityRenderer: ClassVar[int] = ...
    kHighQualityRenderer: ClassVar[int] = ...
    kViewport2Renderer: ClassVar[int] = ...
    kExternalRenderer: ClassVar[int] = ...
    kDepth_8: ClassVar[int] = ...
    kDepth_Float: ClassVar[int] = ...
    kStippleNone: ClassVar[int] = ...
    kStippleDashed: ClassVar[int] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def display(self) -> long: ...  # type: ignore[name-defined]
    def deviceContext(self) -> long: ...  # type: ignore[name-defined]
    @staticmethod
    def active3dView() -> M3dView: ...
    @staticmethod
    def activeAffectedColor() -> MColor: ...  # type: ignore[name-defined]
    @staticmethod
    def activeTemplateColor() -> MColor: ...  # type: ignore[name-defined]
    @staticmethod
    def applicationShell() -> long: ...  # type: ignore[name-defined]
    @staticmethod
    def backgroundColor() -> MColor: ...  # type: ignore[name-defined]
    @staticmethod
    def backgroundColorBottom() -> MColor: ...  # type: ignore[name-defined]
    @staticmethod
    def backgroundColorTop() -> MColor: ...  # type: ignore[name-defined]
    def beginGL(self) -> self: ...  # type: ignore[name-defined]
    def beginProjMatrixOverride(self, projectionMatrix) -> self: ...  # type: ignore[name-defined]
    def beginSelect(self, buffer=..., size=...) -> self: ...  # type: ignore[name-defined]
    @overload
    def beginXorDrawing(self, drawOrthographic=..., disableDepthTesting=..., lineWidth=..., stipplePattern=..., lineColor=...) -> self: ...  # type: ignore[name-defined]
    @overload
    def beginXorDrawing(self) -> Any: ...  # type: ignore[overload-cannot-match]
    def colorAtIndex(self, index, table=...) -> MColor: ...  # type: ignore[name-defined]
    def colorMask(self, *args, **kwargs): ...
    def disallowPolygonOffset(self) -> bool: ...
    @staticmethod
    def displayStatus(path) -> int: ...
    def displayStyle(self) -> int: ...
    def drawText(self, text, position, textPosition=...) -> self: ...  # type: ignore[name-defined]
    def endGL(self) -> self: ...  # type: ignore[name-defined]
    def endProjMatrixOverride(self) -> self: ...  # type: ignore[name-defined]
    def endSelect(self) -> int: ...
    @overload
    def endXorDrawing(self) -> self: ...  # type: ignore[name-defined]
    @overload
    def endXorDrawing(self) -> Any: ...  # type: ignore[overload-cannot-match]
    @staticmethod
    def get3dView(index) -> M3dView: ...
    def getCamera(self) -> MDagPath: ...  # type: ignore[name-defined]
    def getColorIndexAndTable(self, *args, **kwargs): ...
    def getLightCount(self, visible=...) -> int: ...
    def getLightIndex(self, lightNumber) -> int: ...
    def getLightPath(self, lightNumber) -> MDagPath: ...  # type: ignore[name-defined]
    def getLightingMode(self) -> int: ...
    @staticmethod
    def getM3dViewFromModelEditor(name) -> M3dView: ...
    @staticmethod
    def getM3dViewFromModelPanel(name) -> M3dView: ...
    def getRendererName(self) -> int: ...
    def getScreenPosition(self, *args, **kwargs): ...
    @staticmethod
    def hiliteColor() -> MColor: ...  # type: ignore[name-defined]
    def initNames(self) -> self: ...  # type: ignore[name-defined]
    @staticmethod
    def isBackgroundGradient() -> bool: ...
    def isLightVisible(self, lightNumber) -> bool: ...
    def isShadeActiveOnly(self) -> bool: ...
    def isVisible(self) -> bool: ...
    @staticmethod
    def leadColor() -> MColor: ...  # type: ignore[name-defined]
    @staticmethod
    def liveColor() -> MColor: ...  # type: ignore[name-defined]
    def loadName(self, int) -> self: ...  # type: ignore[name-defined]
    def modelViewMatrix(self) -> MMatrix: ...  # type: ignore[name-defined]
    def multipleDrawEnabled(self) -> bool: ...
    def multipleDrawPassCount(self) -> int: ...
    def numActiveColors(self) -> int: ...
    def numDormantColors(self) -> int: ...
    def numUserDefinedColors(self) -> int: ...
    @staticmethod
    def numberOf3dViews() -> int: ...
    def objectDisplay(self) -> int: ...
    def objectListFilterName(self) -> string: ...  # type: ignore[name-defined]
    def playblastPortHeight(self) -> int: ...
    def playblastPortWidth(self) -> int: ...
    def pluginObjectDisplay(self, pluginDisplayFilter) -> bool: ...
    def popName(self) -> self: ...  # type: ignore[name-defined]
    def popViewport(self) -> self: ...  # type: ignore[name-defined]
    def portHeight(self) -> int: ...
    def portWidth(self) -> int: ...
    def projectionMatrix(self) -> MMatrix: ...  # type: ignore[name-defined]
    def pushName(self, int) -> self: ...  # type: ignore[name-defined]
    def pushViewport(self, x, y, width, height) -> self: ...  # type: ignore[name-defined]
    def readBufferTo2dTexture(self, x, y, width, height) -> self: ...  # type: ignore[name-defined]
    def readColorBuffer(self, image, readRGBA=...) -> self: ...  # type: ignore[name-defined]
    def readDepthMap(self, x, y, width, heigth, bufferPtr, depthMapPrecision) -> self: ...  # type: ignore[name-defined]
    @staticmethod
    def referenceLayerColor() -> MColor: ...  # type: ignore[name-defined]
    def refresh(self, all=..., force=..., offscreen=...) -> self: ...  # type: ignore[name-defined]
    def renderOverrideName(self) -> string: ...  # type: ignore[name-defined]
    def rendererString(self) -> string: ...  # type: ignore[name-defined]
    def scheduleRefresh(self) -> self: ...  # type: ignore[name-defined]
    @staticmethod
    def scheduleRefreshAllViews() -> None: ...
    def selectMode(self) -> bool: ...
    def setCamera(self, camera) -> self: ...  # type: ignore[name-defined]
    def setColorMask(self, r, g, b, a) -> self: ...  # type: ignore[name-defined]
    def setDisallowPolygonOffset(self, v) -> self: ...  # type: ignore[name-defined]
    def setDisplayStyle(self, style, activeOnly=...) -> self: ...  # type: ignore[name-defined]
    @overload
    def setDrawColor(self, index, table=...) -> self: ...  # type: ignore[name-defined]
    @overload
    def setDrawColor(self, color) -> self: ...  # type: ignore[name-defined]
    def setDrawColorAndAlpha(self, color) -> self: ...  # type: ignore[name-defined]
    def setMultipleDrawEnable(self, enable) -> self: ...  # type: ignore[name-defined]
    def setMultipleDrawPassCount(self, count) -> self: ...  # type: ignore[name-defined]
    def setObjectDisplay(self, displayMask) -> self: ...  # type: ignore[name-defined]
    def setObjectListFilterName(self, name) -> self: ...  # type: ignore[name-defined]
    def setPluginObjectDisplay(self, pluginDisplayFilter, on) -> self: ...  # type: ignore[name-defined]
    def setRenderOverrideName(self, name) -> self: ...  # type: ignore[name-defined]
    def setShowObjectFilterNameInHUD(self, show) -> self: ...  # type: ignore[name-defined]
    def setShowViewSelectedChildren(self, show) -> self: ...  # type: ignore[name-defined]
    def setUserDefinedColor(self, index, color) -> self: ...  # type: ignore[name-defined]
    def setViewSelectedPrefix(self, prefix) -> self: ...  # type: ignore[name-defined]
    def showObjectFilterNameInHUD(self) -> bool: ...
    def showViewSelectedChildren(self) -> bool: ...
    @staticmethod
    def templateColor() -> MColor: ...  # type: ignore[name-defined]
    def textureMode(self) -> bool: ...
    def twoSidedLighting(self) -> bool: ...
    def updateViewingParameters(self) -> self: ...  # type: ignore[name-defined]
    def userDefinedColorIndex(self, index) -> int: ...
    def usingDefaultMaterial(self) -> bool: ...
    def usingMipmappedTextures(self) -> bool: ...
    def viewSelectedPrefix(self) -> string: ...  # type: ignore[name-defined]
    def viewToObjectSpace(self, x_pos, y_pos, localMatrixInverse, oPt, oVector) -> self: ...  # type: ignore[name-defined]
    @overload
    def viewToWorld(self, x_pos, y_pos, worldPt, worldVector) -> self: ...  # type: ignore[name-defined]
    @overload
    def viewToWorld(self, x_pos, y_pos, nearClipPt, farClipPt) -> self: ...  # type: ignore[name-defined]
    def viewport(self, *args, **kwargs): ...
    def widget(self) -> long: ...  # type: ignore[name-defined]
    def window(self) -> long: ...  # type: ignore[name-defined]
    def wireframeOnShaded(self) -> bool: ...
    def wireframeOnlyInShadedMode(self) -> bool: ...
    def worldToView(self, *args, **kwargs): ...
    def writeColorBuffer(self, image, x=..., y=...) -> self: ...  # type: ignore[name-defined]
    def xray(self) -> bool: ...
    def xrayJoints(self) -> bool: ...
    def viewIsFiltered(self) -> bool: ...
    def filteredObjectList(self) -> MSelectionList: ...  # type: ignore[name-defined]

class MCursor:
    kDefaultCursor: ClassVar[MCursor] = ...
    kCrossHairCursor: ClassVar[MCursor] = ...
    kDoubleCrossHairCursor: ClassVar[MCursor] = ...
    kEditCursor: ClassVar[MCursor] = ...
    kPencilCursor: ClassVar[MCursor] = ...
    kHandCursor: ClassVar[MCursor] = ...
    def __lt__(self, value) -> bool: ...
    def __le__(self, value) -> bool: ...
    def __eq__(self, value) -> bool: ...
    def __ne__(self, value) -> bool: ...
    def __gt__(self, value) -> bool: ...
    def __ge__(self, value) -> bool: ...
    def __init__(self, *args, **kwargs) -> None: ...

class MDrawData:
    def __init__(self, *args, **kwargs) -> None: ...
    def geometry(self) -> long: ...  # type: ignore[name-defined]

class MDrawInfo:
    def __init__(self, *args, **kwargs) -> None: ...
    def canDrawComponent(self, isDisplayOn, compMask) -> bool: ...
    def completelyInside(self) -> bool: ...
    @overload
    def displayStatus(self) -> int: ...
    @overload
    def displayStatus(self) -> Any: ...  # type: ignore[overload-cannot-match]
    @overload
    def displayStyle(self) -> int: ...
    @overload
    def displayStyle(self) -> Any: ...  # type: ignore[overload-cannot-match]
    def getPrototype(self, drawHandler) -> MDrawRequest: ...
    def inSelect(self) -> bool: ...
    def inUserInteraction(self) -> bool: ...
    def inclusiveMatrix(self) -> MMatrix: ...  # type: ignore[name-defined]
    def multiPath(self) -> MDagPath: ...  # type: ignore[name-defined]
    def objectDisplayStatus(self, displayObj) -> bool: ...
    def pluginObjectDisplayStatus(self, pluginDisplayFilter) -> bool: ...
    def projectionMatrix(self) -> MMatrix: ...  # type: ignore[name-defined]
    def setMultiPath(self, path) -> self: ...  # type: ignore[name-defined]
    def userChangingViewContext(self) -> bool: ...
    def view(self) -> M3dView: ...

class MDrawRequest:
    view: Incomplete
    multiPath: Incomplete
    component: Incomplete
    drawData: Incomplete
    displayStatus: Any
    displayCulling: Incomplete
    displayCullOpposite: Incomplete
    displayStyle: Any
    color: Incomplete
    material: Incomplete
    isTransparent: Incomplete
    drawLast: Incomplete
    token: Incomplete
    matrix: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...
    def planeColor(self, table) -> int: ...
    def setPlaneColor(self, value, table) -> self: ...  # type: ignore[name-defined]

class MEvent:
    shiftKey: ClassVar[int] = ...
    controlKey: ClassVar[int] = ...
    kLeftMouse: ClassVar[int] = ...
    kMiddleMouse: ClassVar[int] = ...
    position: Incomplete
    modifiers: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...
    def getWindowPosition(self, *args, **kwargs): ...
    def mouseButton(self) -> mouseButtonType: ...  # type: ignore[name-defined]
    def isModifierKeyRelease(self) -> bool: ...
    def isModifierNone(self) -> bool: ...
    def isModifierShift(self) -> bool: ...
    def isModifierControl(self) -> bool: ...
    def isModifierLeftMouseButton(self) -> bool: ...
    def isModifierMiddleMouseButton(self) -> bool: ...

class MFnManip3D(maya.api.OpenMaya.MFnTransform):
    isVisible: Incomplete
    manipScale: Incomplete
    isOptimizePlaybackOn: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...
    @staticmethod
    def deleteManipulator(manip) -> None: ...
    @staticmethod
    def globalSize() -> float: ...
    @staticmethod
    def handleSize() -> float: ...
    @staticmethod
    def lineSize() -> float: ...
    def rotateXYZValue(self, valIndex) -> MEulerRotation: ...  # type: ignore[name-defined]
    @staticmethod
    def drawPlaneHandles() -> bool: ...
    @staticmethod
    def setGlobalSize(float) -> None: ...
    @staticmethod
    def setHandleSize(float) -> None: ...
    @staticmethod
    def setLineSize(float) -> None: ...
    @staticmethod
    def setDrawPlaneHandles(bool) -> None: ...

class MFnCircleSweepManip(MFnManip3D):
    startPoint: Incomplete
    endPoint: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...
    def angleIndex(self) -> int: ...
    def axisIndex(self) -> int: ...
    def centerIndex(self) -> int: ...
    def connectToAnglePlug(self, anglePlug) -> self: ...  # type: ignore[name-defined]
    def create(self, manipName=..., angleName=...) -> MObject: ...  # type: ignore[override]
    def endCircleIndex(self) -> int: ...
    def setAngle(self, angle) -> self: ...  # type: ignore[name-defined]
    def setCenterPoint(self, centerPoint) -> self: ...  # type: ignore[name-defined]
    def setDrawAsArc(self, state) -> self: ...  # type: ignore[name-defined]
    def setNormal(self, normal) -> self: ...  # type: ignore[name-defined]
    def setRadius(self, radius) -> self: ...  # type: ignore[name-defined]
    def startCircleIndex(self) -> int: ...

class MFnCurveSegmentManip(MFnManip3D):
    startParameter: Incomplete
    endParameter: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...
    def connectToCurvePlug(self, curvePlug) -> self: ...  # type: ignore[name-defined]
    def connectToEndParamPlug(self, endParamPlug) -> self: ...  # type: ignore[name-defined]
    def connectToStartParamPlug(self, startParamPlug) -> self: ...  # type: ignore[name-defined]
    def create(self, manipName=..., startParamName=..., endParamName=...) -> MObject: ...  # type: ignore[name-defined]
    def curveIndex(self) -> int: ...
    def endParamIndex(self) -> int: ...
    def startParamIndex(self) -> int: ...

class MFnDirectionManip(MFnManip3D):
    def __init__(self, *args, **kwargs) -> None: ...
    def connectToDirectionPlug(self, directionPlug) -> self: ...  # type: ignore[name-defined]
    def create(self, manipName=..., directionName=...) -> MObject: ...  # type: ignore[override]
    def directionIndex(self) -> int: ...
    def endPointIndex(self) -> int: ...
    def setDirection(self, direction) -> self: ...  # type: ignore[name-defined]
    def setDrawStart(self, bool) -> self: ...  # type: ignore[name-defined]
    def setNormalizeDirection(self, bool) -> self: ...  # type: ignore[name-defined]
    def setStartPoint(self, startPoint) -> self: ...  # type: ignore[name-defined]
    def startPointIndex(self) -> int: ...

class MFnDiscManip(MFnManip3D):
    def __init__(self, *args, **kwargs) -> None: ...
    def angleIndex(self) -> int: ...
    def axisIndex(self) -> int: ...
    def centerIndex(self) -> int: ...
    def connectToAnglePlug(self, directionPlug) -> self: ...  # type: ignore[name-defined]
    def create(self, manipName=..., angleName=...) -> MObject: ...  # type: ignore[override]
    def setAngle(self, angle) -> self: ...  # type: ignore[name-defined]
    def setCenterPoint(self, centerPoint) -> self: ...  # type: ignore[name-defined]
    def setNormal(self, normal) -> self: ...  # type: ignore[name-defined]
    def setRadius(self, radius) -> self: ...  # type: ignore[name-defined]

class MFnDistanceManip(MFnManip3D):
    isDrawStartOn: Incomplete
    isDrawLineOn: Incomplete
    scalingFactor: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...
    def connectToDistancePlug(self, directionPlug) -> self: ...  # type: ignore[name-defined]
    def create(self, manipName=..., distanceName=...) -> MObject: ...  # type: ignore[override]
    def currentPointIndex(self) -> int: ...
    def directionIndex(self) -> int: ...
    def distanceIndex(self) -> int: ...
    def setDirection(self, direction) -> self: ...  # type: ignore[name-defined]
    def setStartPoint(self, startPoint) -> self: ...  # type: ignore[name-defined]
    def startPointIndex(self) -> int: ...

class MFnFreePointTriadManip(MFnManip3D):
    kYZPlane: ClassVar[int] = ...
    kXZPlane: ClassVar[int] = ...
    kXYPlane: ClassVar[int] = ...
    kViewPlane: ClassVar[int] = ...
    isDrawAxesOn: Incomplete
    isSnapModeOn: Incomplete
    isKeyframeAllOn: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...
    def connectToPointPlug(self, pointPlug) -> self: ...  # type: ignore[name-defined]
    def create(self, manipName=..., pointName=...) -> MObject: ...  # type: ignore[override]
    def pointIndex(self) -> int: ...
    def setDirection(self, direction) -> self: ...  # type: ignore[name-defined]
    def setDrawArrowHead(self, state) -> self: ...  # type: ignore[name-defined]
    def setGlobalTriadPlane(self, whichPlane) -> self: ...  # type: ignore[name-defined]
    def setPoint(self, pointValue) -> self: ...  # type: ignore[name-defined]

class MFnPointOnCurveManip(MFnManip3D):
    isDrawCurveOn: Incomplete
    parameter: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...
    def connectToCurvePlug(self, curvePlug) -> self: ...  # type: ignore[name-defined]
    def connectToParamPlug(self, paramPlug) -> self: ...  # type: ignore[name-defined]
    def create(self, manipName=..., paramName=...) -> MObject: ...  # type: ignore[override]
    def curveIndex(self) -> int: ...
    def curvePoint(self) -> MPoint: ...  # type: ignore[name-defined]
    def paramIndex(self) -> int: ...

class MFnPointOnSurfaceManip(MFnManip3D):
    uParam: Incomplete
    vParam: Incomplete
    isDrawSurfaceOn: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...
    def connectToParamPlug(self, paramPlug) -> self: ...  # type: ignore[name-defined]
    def connectToSurfacePlug(self, surfacePlug) -> self: ...  # type: ignore[name-defined]
    def create(self, manipName=..., paramName=...) -> MObject: ...  # type: ignore[override]
    def paramIndex(self) -> int: ...
    def setDrawArrows(self, state) -> self: ...  # type: ignore[name-defined]
    def surfaceIndex(self) -> int: ...

class MFnRotateManip(MFnManip3D):
    kObjectSpace: ClassVar[int] = ...
    kWorldSpace: ClassVar[int] = ...
    kGimbal: ClassVar[int] = ...
    isSnapModeOn: Incomplete
    snapIncrement: Incomplete
    rotateMode: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...
    def connectToRotationCenterPlug(self, rotationCenterPlug) -> self: ...  # type: ignore[name-defined]
    def connectToRotationPlug(self, rotationPlug) -> self: ...  # type: ignore[name-defined]
    def create(self, manipName=..., rotationName=...) -> MObject: ...  # type: ignore[override]
    def displayWithNode(self, node) -> self: ...  # type: ignore[name-defined]
    def rotationCenterIndex(self) -> int: ...
    def rotationIndex(self) -> int: ...
    def setInitialRotation(self, rotation) -> self: ...  # type: ignore[name-defined]
    def setRotationCenter(self, rotationCenter) -> self: ...  # type: ignore[name-defined]

class MFnScaleManip(MFnManip3D):
    kDefaultOrientation: ClassVar[int] = ...
    kArbitraryOrientation: ClassVar[int] = ...
    isSnapModeOn: Incomplete
    snapIncrement: Incomplete
    orientation: Incomplete
    orientationMode: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...
    def connectToScaleCenterPlug(self, scaleCenterPlug) -> self: ...  # type: ignore[name-defined]
    def connectToScalePlug(self, scalePlug) -> self: ...  # type: ignore[name-defined]
    def create(self, manipName=..., scaleName=...) -> MObject: ...  # type: ignore[override]
    def displayWithNode(self, node) -> self: ...  # type: ignore[name-defined]
    def scaleCenterIndex(self) -> int: ...
    def scaleIndex(self) -> int: ...
    def setInitialScale(self, scale) -> self: ...  # type: ignore[name-defined]

class MFnStateManip(MFnManip3D):
    maxStates: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...
    def connectToStatePlug(self, statePlug) -> self: ...  # type: ignore[name-defined]
    def create(self, manipName=..., stateName=...) -> MObject: ...  # type: ignore[override]
    def positionIndex(self) -> int: ...
    def setInitialState(self, initialState) -> self: ...  # type: ignore[name-defined]
    def state(self) -> int: ...
    def stateIndex(self) -> int: ...

class MFnToggleManip(MFnManip3D):
    startPoint: Incomplete
    direction: Incomplete
    length: Incomplete
    toggle: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...
    def connectToTogglePlug(self, togglePlug) -> self: ...  # type: ignore[name-defined]
    def create(self, manipName=..., toggleName=...) -> MObject: ...  # type: ignore[override]
    def directionIndex(self) -> int: ...
    def lengthIndex(self) -> int: ...
    def startPointIndex(self) -> int: ...
    def toggleIndex(self) -> int: ...

class MHWShaderSwatchGenerator(maya.api.OpenMayaRender.MSwatchRenderBase):
    def __init__(self, *args, **kwargs) -> None: ...
    @staticmethod
    def createObj(obj, renderObj, res) -> MSwatchRenderBase: ...  # type: ignore[name-defined]
    def doIteration(self) -> bool: ...
    @staticmethod
    def getSwatchBackgroundColor() -> MColor: ...  # type: ignore[name-defined]
    @staticmethod
    def initialize() -> string: ...  # type: ignore[name-defined]

class MManipData:
    def __init__(self, *args, **kwargs) -> None: ...
    def asBool(self) -> bool: ...
    def asDouble(self) -> float: ...
    def asFloat(self) -> float: ...
    def asLong(self) -> int: ...
    def asMObject(self) -> int: ...
    def asShort(self) -> int: ...
    def asUnsigned(self) -> int: ...
    def isSimple(self) -> bool: ...

class MMaterial:
    kColor: ClassVar[int] = ...
    kTransparency: ClassVar[int] = ...
    kAmbientColor: ClassVar[int] = ...
    kIncandescence: ClassVar[int] = ...
    kBumpMap: ClassVar[int] = ...
    kDiffuse: ClassVar[int] = ...
    kTransluscence: ClassVar[int] = ...
    kRoughness: ClassVar[int] = ...
    kHighlightSize: ClassVar[int] = ...
    kWhiteness: ClassVar[int] = ...
    kCosinePower: ClassVar[int] = ...
    kEccentricity: ClassVar[int] = ...
    kSpecularRollOff: ClassVar[int] = ...
    kSpecularColor: ClassVar[int] = ...
    kReflectivity: ClassVar[int] = ...
    kReflectedColor: ClassVar[int] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def applyTexture(self, view, data) -> self: ...  # type: ignore[name-defined]
    @staticmethod
    def defaultMaterial() -> MMaterial: ...
    def evaluateDiffuse(self) -> self: ...  # type: ignore[name-defined]
    def evaluateEmission(self) -> self: ...  # type: ignore[name-defined]
    def evaluateMaterial(self, view, path) -> self: ...  # type: ignore[name-defined]
    def evaluateShininess(self) -> self: ...  # type: ignore[name-defined]
    def evaluateSpecular(self) -> self: ...  # type: ignore[name-defined]
    def evaluateTexture(self, data) -> self: ...  # type: ignore[name-defined]
    def getDiffuse(self) -> MColor: ...  # type: ignore[name-defined]
    def getEmission(self) -> MColor: ...  # type: ignore[name-defined]
    def getHasTransparency(self) -> bool: ...
    def getHwShaderNode(self) -> MPxHwShaderNode: ...
    def getShininess(self) -> float: ...
    def getSpecular(self) -> MColor: ...  # type: ignore[name-defined]
    def getTextureTransformation(self, data, texXform) -> self: ...  # type: ignore[name-defined]
    def materialIsTextured(self) -> bool: ...
    def setMaterial(self, path, hasTransparency) -> self: ...  # type: ignore[name-defined]
    def shadingEngine(self) -> MObject: ...  # type: ignore[name-defined]
    def textureImage(self, image, color, chan, dagPath, xRes=..., yRes=...) -> self: ...  # type: ignore[name-defined]

class MMaterialArray:
    sizeIncrement: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...
    def __len__(self) -> int: ...
    def __getitem__(self, key): ...
    def append(self, element) -> self: ...  # type: ignore[name-defined]
    def clear(self) -> self: ...  # type: ignore[name-defined]
    def copy(self, source) -> self: ...  # type: ignore[name-defined]
    def insert(self, element, index) -> self: ...  # type: ignore[name-defined]
    def remove(self, index) -> self: ...  # type: ignore[name-defined]
    def set(self, element, index) -> self: ...  # type: ignore[name-defined]
    def setLength(self, length) -> self: ...  # type: ignore[name-defined]

class MPaintMessage(maya.api.OpenMaya.MMessage):
    @staticmethod
    def addVertexColorCallback(function, clientData=...) -> id: ...  # type: ignore[valid-type]

class MPanelCanvas:
    kGraphEditorUndefined: ClassVar[int] = ...
    kGraphEditorBackground: ClassVar[int] = ...
    kGraphEditorFirstDefaultDraw: ClassVar[int] = ...
    kGraphEditorGrid: ClassVar[int] = ...
    kGraphEditorAxisLabels: ClassVar[int] = ...
    kGraphEditorCurves: ClassVar[int] = ...
    kGraphEditorCurveNames: ClassVar[int] = ...
    kGraphEditorTimeMarker: ClassVar[int] = ...
    kGraphEditorRetimeToolText: ClassVar[int] = ...
    kGraphEditorLastDefaultDraw: ClassVar[int] = ...
    kGraphEditorOverlayTexture: ClassVar[int] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def addPrimitive(self, *args, **kwargs): ...
    def createFloatVertexBuffer(self, tVals, yVals, colors) -> int: ...
    def createTimeVertexBuffer(self, tVals, yVals, colors) -> int: ...
    def createPrimitive(self, primType, bufferId, startIndex, numVertices, props) -> int: ...
    def destroyVertexBuffer(self, bufferId) -> Any: ...
    def destroyPrimitive(self, primitiveId) -> Any: ...
    def isAutoRefresh(self) -> bool: ...
    def isLayerVisible(self, int) -> bool: ...
    def registerDrawUICallback(self, layer, cb, clientData) -> callbackId: ...  # type: ignore[name-defined]
    def removePrimitive(self, *args, **kwargs): ...
    def setLayerVisible(self, int, bool) -> Any: ...
    def refresh(self) -> Any: ...
    def setAutoRefresh(self) -> Any: ...
    def supportsUIDrawing(self) -> bool: ...
    def isValid(self) -> bool: ...
    def unregisterDrawUICallback(self, callbackId) -> Any: ...

class MDrawProperties:
    color: Incomplete
    lineWidth: Incomplete
    lineStyle: Incomplete
    pointSize: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...

class MPanelCanvasInfo:
    def __init__(self, *args, **kwargs) -> None: ...
    def getViewportBounds(self) -> Any: ...
    def getViewportSize(self) -> Any: ...
    def name(self) -> MString: ...  # type: ignore[name-defined]
    def setViewportBounds(self, bounds) -> Any: ...
    def supportsUIDrawing(self) -> bool: ...

class RenderParameters:
    baseColor: Incomplete
    unfiltered: Incomplete
    showAlphaMask: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...

class MPxHardwareShader(maya.api.OpenMaya.MPxNode):
    kIsTransparent: ClassVar[int] = ...
    kNoTransparencyFrontBackCull: ClassVar[int] = ...
    kNoTransparencyPolygonSort: ClassVar[int] = ...
    outColor: ClassVar[maya.api.OpenMaya.MObject] = ...
    outColorR: ClassVar[maya.api.OpenMaya.MObject] = ...
    outColorG: ClassVar[maya.api.OpenMaya.MObject] = ...
    outColorB: ClassVar[maya.api.OpenMaya.MObject] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    @staticmethod
    def findResource(name, shaderPath) -> string: ...  # type: ignore[name-defined]
    def getAvailableImages(self, *args, **kwargs): ...
    @staticmethod
    def getHardwareShader(object) -> TODO: ...  # type: ignore[name-defined]
    def profile(self) -> MRenderProfile: ...  # type: ignore[name-defined]
    def renderImage(self, *args, **kwargs): ...
    def renderSwatchImage(self, image) -> self: ...  # type: ignore[name-defined]
    def setUniformParameters(self, parameters, remapCurrentValues=..., dagModifier=...) -> self: ...  # type: ignore[name-defined]
    def setVaryingParameters(self, parameters, remapCurrentValues=..., dagModifier=...) -> self: ...  # type: ignore[name-defined]
    def transparencyOptions(self) -> int: ...

class ShaderContext:
    path: Incomplete
    shadingEngine: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...

class MPxHwShaderNode(maya.api.OpenMaya.MPxNode):
    kWriteNone: ClassVar[int] = ...
    kWriteVertexArray: ClassVar[int] = ...
    kWriteNormalArray: ClassVar[int] = ...
    kWriteColorArrays: ClassVar[int] = ...
    kWriteTexCoordArrays: ClassVar[int] = ...
    kWriteAll: ClassVar[int] = ...
    kDirtyNone: ClassVar[int] = ...
    kDirtyVertexArray: ClassVar[int] = ...
    kDirtyNormalArray: ClassVar[int] = ...
    kDirtyColorArrays: ClassVar[int] = ...
    kDirtyTexCoordArrays: ClassVar[int] = ...
    kDirtyAll: ClassVar[int] = ...
    kIsTransparent: ClassVar[int] = ...
    kNoTransparencyFrontBackCull: ClassVar[int] = ...
    kNoTransparencyPolygonSort: ClassVar[int] = ...
    outColor: ClassVar[maya.api.OpenMaya.MObject] = ...
    outColorR: ClassVar[maya.api.OpenMaya.MObject] = ...
    outColorG: ClassVar[maya.api.OpenMaya.MObject] = ...
    outColorB: ClassVar[maya.api.OpenMaya.MObject] = ...
    outTransparency: ClassVar[maya.api.OpenMaya.MObject] = ...
    outTransparencyR: ClassVar[maya.api.OpenMaya.MObject] = ...
    outTransparencyG: ClassVar[maya.api.OpenMaya.MObject] = ...
    outTransparencyB: ClassVar[maya.api.OpenMaya.MObject] = ...
    outMatteOpacity: ClassVar[maya.api.OpenMaya.MObject] = ...
    outMatteOpacityR: ClassVar[maya.api.OpenMaya.MObject] = ...
    outMatteOpacityG: ClassVar[maya.api.OpenMaya.MObject] = ...
    outMatteOpacityB: ClassVar[maya.api.OpenMaya.MObject] = ...
    outGlowColor: ClassVar[maya.api.OpenMaya.MObject] = ...
    outGlowColorR: ClassVar[maya.api.OpenMaya.MObject] = ...
    outGlowColorG: ClassVar[maya.api.OpenMaya.MObject] = ...
    outGlowColorB: ClassVar[maya.api.OpenMaya.MObject] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def bind(self, request, view) -> self: ...  # type: ignore[name-defined]
    @overload
    def colorsPerVertex(self) -> int: ...
    @overload
    def colorsPerVertex(self) -> Any: ...  # type: ignore[overload-cannot-match]
    def currentPath(self) -> MDagPath: ...  # type: ignore[name-defined]
    def currentShadingEngine(self) -> MObject: ...  # type: ignore[name-defined]
    def dirtyMask(self) -> int: ...
    def geometry(self, request, view, prim, writable, indexCount, indexArray, vertexCount, vertexIDs, vertexArray, normalCount, normalArrays, colorCount, colorArrays, texCoordCount, texCoordArrays) -> self: ...  # type: ignore[name-defined]
    def getAvailableImages(self, *args, **kwargs): ...
    def getColorSetNames(self, names) -> int: ...
    @staticmethod
    def getHwShaderNode(object) -> MPxHwShaderNode: ...
    def getTexCoordSetNames(self, names) -> int: ...
    def glBind(self, shapePath) -> self: ...  # type: ignore[name-defined]
    def glGeometry(self, shapePath, prim, writable, indexCount, indexArray, vertexCount, vertexIDs, vertexArray, normalCount, normalArrays, colorCount, colorArrays, texCoordCount, texCoordArrays) -> self: ...  # type: ignore[name-defined]
    def glUnbind(self, shapePath) -> self: ...  # type: ignore[name-defined]
    def hasTransparency(self) -> bool: ...
    def invertTexCoords(self) -> bool: ...
    @overload
    def normalsPerVertex(self) -> int: ...
    @overload
    def normalsPerVertex(self) -> Any: ...  # type: ignore[overload-cannot-match]
    def provideVertexIDs(self) -> bool: ...
    def renderImage(self, *args, **kwargs): ...
    def renderSwatchImage(self, *args, **kwargs): ...
    def supportsBatching(self) -> bool: ...
    @overload
    def texCoordsPerVertex(self) -> int: ...
    @overload
    def texCoordsPerVertex(self) -> Any: ...  # type: ignore[overload-cannot-match]
    def transparencyOptions(self) -> int: ...
    def unbind(self, request, view) -> self: ...  # type: ignore[name-defined]

class MPxLocatorNode(maya.api.OpenMaya.MPxNode):
    underWorldObject: ClassVar[maya.api.OpenMaya.MObject] = ...
    localPosition: ClassVar[maya.api.OpenMaya.MObject] = ...
    localPositionX: ClassVar[maya.api.OpenMaya.MObject] = ...
    localPositionY: ClassVar[maya.api.OpenMaya.MObject] = ...
    localPositionZ: ClassVar[maya.api.OpenMaya.MObject] = ...
    worldPosition: ClassVar[maya.api.OpenMaya.MObject] = ...
    worldPositionX: ClassVar[maya.api.OpenMaya.MObject] = ...
    worldPositionY: ClassVar[maya.api.OpenMaya.MObject] = ...
    worldPositionZ: ClassVar[maya.api.OpenMaya.MObject] = ...
    localScale: ClassVar[maya.api.OpenMaya.MObject] = ...
    localScaleX: ClassVar[maya.api.OpenMaya.MObject] = ...
    localScaleY: ClassVar[maya.api.OpenMaya.MObject] = ...
    localScaleZ: ClassVar[maya.api.OpenMaya.MObject] = ...
    nodeBoundingBox: ClassVar[maya.api.OpenMaya.MObject] = ...
    nodeBoundingBoxMin: ClassVar[maya.api.OpenMaya.MObject] = ...
    nodeBoundingBoxMinX: ClassVar[maya.api.OpenMaya.MObject] = ...
    nodeBoundingBoxMinY: ClassVar[maya.api.OpenMaya.MObject] = ...
    nodeBoundingBoxMinZ: ClassVar[maya.api.OpenMaya.MObject] = ...
    nodeBoundingBoxMax: ClassVar[maya.api.OpenMaya.MObject] = ...
    nodeBoundingBoxMaxX: ClassVar[maya.api.OpenMaya.MObject] = ...
    nodeBoundingBoxMaxY: ClassVar[maya.api.OpenMaya.MObject] = ...
    nodeBoundingBoxMaxZ: ClassVar[maya.api.OpenMaya.MObject] = ...
    nodeBoundingBoxSize: ClassVar[maya.api.OpenMaya.MObject] = ...
    nodeBoundingBoxSizeX: ClassVar[maya.api.OpenMaya.MObject] = ...
    nodeBoundingBoxSizeY: ClassVar[maya.api.OpenMaya.MObject] = ...
    nodeBoundingBoxSizeZ: ClassVar[maya.api.OpenMaya.MObject] = ...
    center: ClassVar[maya.api.OpenMaya.MObject] = ...
    boundingBoxCenterX: ClassVar[maya.api.OpenMaya.MObject] = ...
    boundingBoxCenterY: ClassVar[maya.api.OpenMaya.MObject] = ...
    boundingBoxCenterZ: ClassVar[maya.api.OpenMaya.MObject] = ...
    matrix: ClassVar[maya.api.OpenMaya.MObject] = ...
    inverseMatrix: ClassVar[maya.api.OpenMaya.MObject] = ...
    worldMatrix: ClassVar[maya.api.OpenMaya.MObject] = ...
    worldInverseMatrix: ClassVar[maya.api.OpenMaya.MObject] = ...
    parentMatrix: ClassVar[maya.api.OpenMaya.MObject] = ...
    parentInverseMatrix: ClassVar[maya.api.OpenMaya.MObject] = ...
    visibility: ClassVar[maya.api.OpenMaya.MObject] = ...
    intermediateObject: ClassVar[maya.api.OpenMaya.MObject] = ...
    isTemplated: ClassVar[maya.api.OpenMaya.MObject] = ...
    instObjGroups: ClassVar[maya.api.OpenMaya.MObject] = ...
    objectGroups: ClassVar[maya.api.OpenMaya.MObject] = ...
    objectGrpCompList: ClassVar[maya.api.OpenMaya.MObject] = ...
    objectGroupId: ClassVar[maya.api.OpenMaya.MObject] = ...
    objectGroupColor: ClassVar[maya.api.OpenMaya.MObject] = ...
    useObjectColor: ClassVar[maya.api.OpenMaya.MObject] = ...
    objectColor: ClassVar[maya.api.OpenMaya.MObject] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def boundingBox(self) -> MBoundingBox: ...  # type: ignore[name-defined]
    def closestPoint(self, rayPoint, rayDir) -> MPoint: ...  # type: ignore[name-defined]
    def color(self, status) -> int: ...
    def colorRGB(self, status) -> MColor: ...  # type: ignore[name-defined]
    def draw(self, view, path, style, status) -> self: ...  # type: ignore[name-defined]
    def drawLast(self) -> bool: ...
    def excludeAsLocator(self) -> bool: ...
    def isBounded(self) -> bool: ...
    def isTransparent(self) -> bool: ...
    def useClosestPointForSelection(self) -> bool: ...
    def getShapeSelectionMask(self) -> MSelectionMask: ...  # type: ignore[name-defined]

class MPxManipContainer(maya.api.OpenMaya.MPxNode):
    def __init__(self, *args, **kwargs) -> None: ...
    def addCircleSweepManip(self, manipName, angleName) -> MDagPath: ...  # type: ignore[name-defined]
    def addCurveSegmentManip(self, manipName, startParamName, endParamName) -> MDagPath: ...  # type: ignore[name-defined]
    def addDirectionManip(self, manipName, directionName) -> MDagPath: ...  # type: ignore[name-defined]
    def addDiscManip(self, manipName, angleName) -> MDagPath: ...  # type: ignore[name-defined]
    def addDistanceManip(self, manipName, distanceName) -> MDagPath: ...  # type: ignore[name-defined]
    def addFreePointTriadManip(self, manipName, pointName) -> MDagPath: ...  # type: ignore[name-defined]
    @overload
    def addManipToPlugConversion(self, plug) -> unsignedint: ...  # type: ignore[name-defined]
    @overload
    def addManipToPlugConversion(self) -> Any: ...
    @overload
    def addManipToPlugConversion(self) -> Any: ...  # type: ignore[overload-cannot-match]
    def addMPxManipulatorNode(self, manipTypeName, manipName, proxyManip) -> None: ...
    def addPlugToInViewEditor(self, plug) -> Any: ...
    def addPlugToManipConversion(self, manipIndex) -> Any: ...
    def addPointOnCurveManip(self, manipName, paramName) -> MDagPath: ...  # type: ignore[name-defined]
    def addPointOnSurfaceManip(self, manipName, paramName) -> MDagPath: ...  # type: ignore[name-defined]
    def addRotateManip(self, manipName, rotationName) -> MDagPath: ...  # type: ignore[name-defined]
    def addScaleManip(self, manipName, scaleName) -> MDagPath: ...  # type: ignore[name-defined]
    def addStateManip(self, manipName, stateName) -> MDagPath: ...  # type: ignore[name-defined]
    def addToggleManip(self, manipName, toggleName) -> MDagPath: ...  # type: ignore[name-defined]
    @staticmethod
    def addToManipConnectTable(typeId) -> Any: ...
    def connectToDependNode(self, node) -> None: ...
    def createChildren(self) -> None: ...
    def doPress(self) -> None: ...
    def doDrag(self) -> None: ...
    def doRelease(self) -> None: ...
    def draw(self, view, path, style, status) -> None: ...
    def drawUI(self, drawManager, frameContext) -> None: ...
    def finishAddingManips(self) -> Any: ...
    def getConverterManipDoubleValue(self) -> double: ...  # type: ignore[name-defined]
    def getConverterManipMEulerRotationValue(self) -> MEulereRotation: ...  # type: ignore[name-defined]
    def getConverterManipMMatrixValue(self) -> MMatrix: ...  # type: ignore[name-defined]
    def getConverterManipMPointValue(self) -> MPoint: ...  # type: ignore[name-defined]
    def getConverterManipMTransformationMatrixValue(self) -> MTransformationMatrix: ...  # type: ignore[name-defined]
    def getConverterManipMVectorValue(self) -> MVector: ...  # type: ignore[name-defined]
    def getConverterManipUIntValue(self) -> unsignedint: ...  # type: ignore[name-defined]
    def getConverterManipValues(self, *args, **kwargs): ...
    def getConverterPlugDoubleValue(self) -> double: ...  # type: ignore[name-defined]
    def getConverterPlugMEulerRotationValue(self) -> MEulerRotation: ...  # type: ignore[name-defined]
    def getConverterPlugMMatrixValue(self) -> MMatrix: ...  # type: ignore[name-defined]
    def getConverterPlugMPointValue(self) -> MPoint: ...  # type: ignore[name-defined]
    def getConverterPlugMVectorValue(self) -> MVector: ...  # type: ignore[name-defined]
    def getConverterPlugValues(self, *args, **kwargs): ...
    @staticmethod
    def initialize() -> None: ...
    def isManipActive(self, manipName, stateName) -> MDagPath: ...  # type: ignore[name-defined]
    def manipToPlugConversion(self, manipIndex) -> MManipData: ...
    @staticmethod
    def newManipulator(*args, **kwargs): ...
    def plugToManipConversion(self, manipIndex) -> MManipData: ...
    def preDrawUI(self, view) -> None: ...
    @staticmethod
    def removeFromManipConnectTable(typeId) -> Any: ...

class MPxSurfaceShapeUI:
    kSelectMeshUVs: ClassVar[int] = ...
    kSelectMeshVerts: ClassVar[int] = ...
    kSelectMeshFaces: ClassVar[int] = ...
    kSelectMeshEdges: ClassVar[int] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def canDrawUV(self) -> bool: ...
    def drawUV(self, view, info) -> self: ...  # type: ignore[name-defined]
    def material(self, path) -> MMaterial: ...
    def materials(self, path, componentFilter, materials, componentSet=...) -> self: ...  # type: ignore[name-defined]
    def select(self, selectInfo, selectionList, worldSpaceSelectPts) -> bool: ...
    def selectUV(self, view, selType, xmin, ymin, xmax, ymax, singleSelect, selList) -> bool: ...
    def snap(self, snapInfo) -> bool: ...
    def surfaceShape(self) -> MPxSurfaceShape: ...  # type: ignore[name-defined]
    @staticmethod
    def surfaceShapeUI(path) -> MPxSurfaceShapeUI: ...

class MPxDragAndDropBehavior:
    def __init__(self, *args, **kwargs) -> None: ...
    def shouldBeUsedFor(self, sourceNode, destinationNode, sourcePlug, destinationPlug) -> bool: ...
    def connectAttrToAttr(self, sourcePlug, destinationPlug, force) -> None: ...
    def connectAttrToNode(self, sourcePlug, destinationNode, force) -> None: ...
    def connectNodeToAttr(self, sourceNode, destinationPlug, force) -> None: ...
    def connectNodeToNode(self, sourceNode, destinationNode, force) -> None: ...

class MPxContext:
    kImage1: ClassVar[int] = ...
    kImage2: ClassVar[int] = ...
    kImage3: ClassVar[int] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def toolOnSetup(self, event) -> None: ...
    def toolOffCleanup(self) -> None: ...
    def doPress(self, event, drawMgr, context) -> None: ...
    def doRelease(self, event, drawMgr, context) -> None: ...
    def doDrag(self, event, drawMgr, context) -> None: ...
    def doHold(self, event, drawMgr, context) -> None: ...
    def drawFeedback(self, event, drawMgr, context) -> None: ...
    def doPtrMoved(self, event, drawMgr, context) -> None: ...
    def doPressLegacy(self, event) -> None: ...
    def doReleaseLegacy(self, event) -> None: ...
    def doDragLegacy(self, event) -> None: ...
    def doHoldLegacy(self, event) -> None: ...
    def doPtrMovedLegacy(self, event) -> None: ...
    def doEnterRegion(self, event) -> None: ...
    def doExitRegion(self, event) -> None: ...
    def helpStateHasChanged(self, event) -> None: ...
    def deleteAction(self) -> None: ...
    def completeAction(self) -> None: ...
    def addManipulator(self, manipulator) -> None: ...
    def deleteManipulators(self) -> None: ...
    def setImage(self, image, index) -> self: ...  # type: ignore[name-defined]
    def image(self, index) -> string: ...  # type: ignore[name-defined]
    def abortAction(self) -> None: ...
    def processNumericalInput(self, values, flags, isAbsolute) -> bool: ...
    def feedbackNumericalInput(self) -> bool: ...
    def argTypeNumericalInput(self, index) -> MSyntax.MArgType: ...
    def setHelpString(self, str) -> self: ...  # type: ignore[name-defined]
    def setTitleString(self, str) -> self: ...  # type: ignore[name-defined]
    def setCursor(self, newCursor) -> self: ...  # type: ignore[name-defined]
    def beginMarquee(self, event) -> self: ...  # type: ignore[name-defined]
    def dragMarquee(self, event) -> self: ...  # type: ignore[name-defined]
    def releaseMarquee(self, *args, **kwargs): ...
    def newToolCommand(self) -> MPxToolCommand: ...
    @overload
    def stringClassName(self) -> string: ...  # type: ignore[name-defined]
    @overload
    def stringClassName(self) -> Any: ...  # type: ignore[overload-cannot-match]
    def inAlternateContext(self) -> bool: ...

class MPxContextCommand:
    def __init__(self, *args, **kwargs) -> None: ...
    def doEditFlags(self) -> None: ...
    def doQueryFlags(self) -> None: ...
    @overload
    def makeObj(self) -> MPxContext: ...
    @overload
    def makeObj(self) -> Any: ...  # type: ignore[overload-cannot-match]
    def appendSyntax(self) -> None: ...
    def parser(self, *args, **kwargs): ...
    def setResult(self) -> None: ...
    def syntax(self, *args, **kwargs): ...

class MSelectInfo(MDrawInfo):
    highestPriority: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...
    def addSelection(self, item, point, list, points, mask, isComponent) -> self: ...  # type: ignore[name-defined]
    def getAlignmentMatrix(self) -> MMatrix: ...  # type: ignore[name-defined]
    def getLocalRay(self, *args, **kwargs): ...
    def isRay(self) -> bool: ...
    def selectClosest(self) -> bool: ...
    def selectForHilite(self, mask) -> bool: ...
    def selectOnHilitedOnly(self) -> bool: ...
    def selectPath(self) -> MDagPath: ...  # type: ignore[name-defined]
    def selectRect(self, *args, **kwargs): ...
    def selectable(self, mask) -> bool: ...
    def selectableComponent(self, displayed, mask) -> bool: ...
    @overload
    def setSnapPoint(self, point) -> bool: ...
    @overload
    def setSnapPoint(self) -> Any: ...
    def singleSelection(self) -> bool: ...
    def view(self) -> M3dView: ...

class MPxSelectionContext(MPxContext):
    def __init__(self, *args, **kwargs) -> None: ...
    def addManipulator(self, manipulator) -> None: ...
    def deleteManipulators(self) -> None: ...
    def setAllowPreSelectHilight(self) -> None: ...
    def setAllowSoftSelect(self) -> None: ...
    def setAllowSymmetry(self) -> None: ...
    def setAllowDoubleClickAction(self) -> None: ...
    def setAllowPaintSelect(self) -> None: ...
    def doDragLegacy(self, event) -> None: ...
    def doHoldLegacy(self, event) -> None: ...
    def doPressLegacy(self, event) -> None: ...
    def doReleaseLegacy(self, event) -> None: ...
    def doDrag(self, event, drawManager, frameContext) -> None: ...
    def doHold(self, event, drawManager, frameContext) -> None: ...
    def doPress(self, event, drawManager, frameContext) -> None: ...
    def doRelease(self, event, drawManager, frameContext) -> None: ...
    def helpStateHasChanged(self, event) -> None: ...
    def abortAction(self) -> None: ...
    def processNumericalInput(self, values, flags, isAbsolute) -> bool: ...
    def feedbackNumericalInput(self) -> bool: ...
    def argTypeNumericalInput(self, index) -> MSyntax.MArgType: ...
    def setImage(self, image, index) -> self: ...  # type: ignore[name-defined]
    def image(self, index) -> string: ...  # type: ignore[name-defined]
    def isSelecting(self) -> bool: ...
    def startPoint(self) -> MPoint: ...  # type: ignore[name-defined]
    def lastDragPoint(self) -> MPoint: ...  # type: ignore[name-defined]
    def newToolCommand(self) -> MPxToolCommand: ...

class MTextureEditorDrawInfo:
    kDrawFunctionFirst: ClassVar[int] = ...
    kDrawWireframe: ClassVar[int] = ...
    kDrawEverything: ClassVar[int] = ...
    kDrawVertexForSelect: ClassVar[int] = ...
    kDrawEdgeForSelect: ClassVar[int] = ...
    kDrawFacetForSelect: ClassVar[int] = ...
    kDrawUVForSelect: ClassVar[int] = ...
    kDrawFunctionLast: ClassVar[int] = ...
    drawingFunction: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...

class MPxToolCommand(maya.api.OpenMaya.MPxCommand):
    def __init__(self, *args, **kwargs) -> None: ...
    def doIt(self, *args, **kwargs): ...
    def cancel(self) -> None: ...
    def finalize(self) -> None: ...
    def doFinalize(self) -> None: ...

class MUiMessage(maya.api.OpenMaya.MMessage):
    @staticmethod
    def addUiDeletedCallback(uiName, function, clientData=...) -> id: ...  # type: ignore[valid-type]
    @staticmethod
    def addCameraChangedCallback(panelName, function, clientData=...) -> id: ...  # type: ignore[valid-type]
    @staticmethod
    def add3dViewDestroyMsgCallback(panelName, function, clientData=...) -> id: ...  # type: ignore[valid-type]
    @staticmethod
    def add3dViewPreRenderMsgCallback(panelName, function, clientData=...) -> id: ...  # type: ignore[valid-type]
    @staticmethod
    def add3dViewPostRenderMsgCallback(panelName, function, clientData=...) -> id: ...  # type: ignore[valid-type]
    @staticmethod
    def add3dViewRendererChangedCallback(panelName, function, clientData=...) -> id: ...  # type: ignore[valid-type]
    @staticmethod
    def add3dViewRenderOverrideChangedCallback(panelName, function, clientData=...) -> id: ...  # type: ignore[valid-type]

class MTimeSliderCustomDrawManager:
    kAbove: ClassVar[int] = ...
    kBelow: ClassVar[int] = ...
    kOn: ClassVar[int] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def registerCustomDrawOn(self, *args, **kwargs): ...
    def registerCustomDrawOutside(self, *args, **kwargs): ...
    def setDrawPrimitives(self, *args, **kwargs): ...
    def clearDrawPrimitives(self, *args, **kwargs): ...
    def deregisterCustomDraw(self, *args, **kwargs): ...
    def setDrawVisible(self, *args, **kwargs): ...
    def requestTimeSliderRedraw(self, *args, **kwargs): ...
    def setBackgroundColor(self, *args, **kwargs): ...
    def setDrawLayer(self, *args, **kwargs): ...
    def setDrawHeight(self, *args, **kwargs): ...
    def setDrawLocation(self, *args, **kwargs): ...
    def setDrawPriority(self, *args, **kwargs): ...
    def setStartPrimitiveEditFunction(self, *args, **kwargs): ...
    def setEditPrimitiveFunction(self, *args, **kwargs): ...
    def setStopPrimitiveEditFunction(self, *args, **kwargs): ...
    def setTooltip(self, *args, **kwargs): ...
    def setSetCopyPrimitivesFunction(self, *args, **kwargs): ...

class MTimeSliderDrawPrimitive:
    kFilledRect: ClassVar[int] = ...
    kUpperOutline: ClassVar[int] = ...
    kFullOutline: ClassVar[int] = ...
    kVerticalLine: ClassVar[int] = ...
    kBracket: ClassVar[int] = ...
    kFrameFlag: ClassVar[int] = ...
    kNone: ClassVar[int] = ...
    kMovePrimitive: ClassVar[int] = ...
    kMoveStartTime: ClassVar[int] = ...
    kMoveEndTime: ClassVar[int] = ...
    priority: Incomplete
    drawType: Incomplete
    startTime: Incomplete
    endTime: Incomplete
    height: Incomplete
    bottom: Incomplete
    color: Incomplete
    label: Incomplete
    tooltip: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...
